//
// Kagi_Ind_7.mq4                                                             . 
//  , , sk@autograf.dp.ua, ICQ 64015987, http://autograf.dp.ua
// 0 
#property copyright "Copyright SK AutoGraf  2008"
#property link      "http://autograf.dp.ua/"
//================================================================================== 1 ==
#property indicator_chart_window                //    
#property indicator_buffers 8                   //   8

extern color Color_1 = DodgerBlue;              //  1
extern color Color_2 = OrangeRed;               //  2

extern int Delta = 31;                          //    
extern int Method = 1;                          //   
extern int Period_MA = 34;                      //  

int Width = 2;                                  //   

double Gor_B1[];                                //   .    
double Gor_B2[];                                //   .    
double Gor_B3[];                                //   .    
double Gor_S1[];                                //   .  
double Gor_S2[];                                //   .  
double Gor_S3[];                                //   .  
double Ver_B[];                                 //    /
double Ver_S[];                                 //    /

int   Vector,                                   //  
      Tip,                                      //   (/)
      Last_V,                                   //   
      BB, SS,                                   //    Buy  Sell       
      Rez,                                      //    
      Ord,                                      //    
      SPREAD;                                   // 

double delta,                                   //      
       Revers,                                  //   
       Pr_Min,                                  //     
       Pr_Max,                                  //    
       Last_Min,                                //      
       Last_Max,                                //     
       bb,                                      //     Buy
       ss;                                      //     Sell
string Prefix = "KAGI7SK_";       
// 3 
int init()
   {
//================================================================================== 4 ==
   string short_name=Prefix+"("+Delta+")";                                                             //???
   IndicatorShortName(short_name);                       //   
//--------------------------------------------------------------------------------- 10 --
   SetIndexBuffer(0,Gor_B1);                             //     . 
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,Width,Color_1); //    
   SetIndexBuffer(1,Gor_B2);                             //     . 
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,Width,Color_1); //    
   SetIndexBuffer(2,Gor_B3);                             //     . 
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,Width,Color_1); //    

   SetIndexBuffer(3,Gor_S1);                             //     . 
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,Width,Color_2); //    
   SetIndexBuffer(4,Gor_S2);                             //     . 
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,Width,Color_2); //    
   SetIndexBuffer(5,Gor_S3);                             //     . 
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,Width,Color_2); //    
//--------------------------------------------------------------------------------- 10 --
   SetIndexBuffer(6,Ver_B);                              //     . 
   SetIndexStyle(6,DRAW_HISTOGRAM,STYLE_SOLID,Width,Color_1);//   - . 
   SetIndexBuffer(7,Ver_S);                              //     . 
   SetIndexStyle(7,DRAW_HISTOGRAM,STYLE_SOLID,Width,Color_2);//   - . 
//================================================================================== 7 ==
   delta = Delta*Point;                                  //   
   SPREAD  = MarketInfo( Symbol(), MODE_SPREAD);         //   
//================================================================================== 7 ==
   return;
   }
// 8 
int start()
   {
//================================================================================== 9 ==
   int 
      counted_bars,                             //   
      i;                                        //  
   double Data;
   string
      Ts_Name;                                  //  . 
//================================================================================== 9 ==
   counted_bars=IndicatorCounted();             //   
   i=Bars-counted_bars-1;                       //    

   if (counted_bars == 0)                       //     start()
      {
      if (Close[i]>Open[i])                     //  
         {
         Tip = 0;                               //   = ,  Buy
         Vector = 1;                            //  - 
         Pr_Min=MathMin(Close[i]-delta,Open[i]);//   
         Pr_Max = Close[i];                     //   
         Last_Min = Pr_Max;                     //      
         Last_Max = Pr_Max;                     //     
         bb = Open[i];
         }
      else                                      //  
         {
         Tip = 1;                               //   = ,  Sell
         Vector = -1;                           //  - 
         Pr_Max=MathMax(Close[i]+delta,Open[i]);//   
         Pr_Min = Close[i];                     //   
         Last_Min = Pr_Min;                     //      
         Last_Max = Pr_Min;                     //     
         ss = Open[i];
         }
      Last_V = i;                               //   
      Vert(i, Pr_Min, Pr_Max, Tip);             //   
      }
//================================================================================== 9 ==
   while(i>=1)                                  //    
      {
      static int First=0;                       //     1 
      if (i==1)                                 //   1 
         {
         if (First==1)                          //      1 
            Last_V++;                           //      1
         First=1;                               //  :    
         }
//================================================================================== 9 ==
      switch(Method)                            //   
         {
         case 1:  Data = iMA(NULL,0,Period_MA,0,MODE_SMMA,PRICE_TYPICAL,i); break;
         default: Data = Close[i];
         }
//================================================================================== 9 ==
      switch(Tip)                               //     
         {

//================================================================================== 9 ==
         case 1:                                         //  
            switch(Vector)                               //  
               {
//--------------------------------------------------------------------------------- 10 --
               case -1:                                  //  (  )
                  if (NormalizeDouble(Data-Last_Min,Digits)<0.0)
                     {
                     Last_Min = Data;
                     Vert(Last_V,Pr_Max,Last_Min,Tip);   //      
                     }
                  if (NormalizeDouble(Data-(Last_Min+delta),Digits)>=0.0)//
                     {
                     Vector = 1;                         //  - 
                     Pr_Min = Last_Min;                  //   
                     Last_Max = Data;   
                     Gorz(Last_V,i,Pr_Min,1);            //   . Close
                     Last_V = i;                         //   
                     if (NormalizeDouble(Last_Max-Pr_Max,Digits)>0.0)//  
                        {
                        Tip = 0;                         //    
                        Vert_Obj(Time[Last_V],Pr_Min,Pr_Max,1);//   i   
               //----
                        bb = Close[i];
                        ss = ss - Close[i];
                        SS = NormalizeDouble(ss/Point,0);
                        Rez = Rez + SS;
                        Ord++;
                        Ts_Name =  Prefix + (Time[i]+1);                        
                        ObjectCreate (Ts_Name, OBJ_TEXT, 0,Time[i], Pr_Min-5*Point);
                        if (SS>0)
                           ObjectSetText(Ts_Name, "+"+SS, 8, "Tahoma", Green);
                        else
                           ObjectSetText(Ts_Name,    ""+SS, 8, "Tahoma", Red);
               //----
                        }
                     Vert(Last_V,Pr_Min,Last_Max,Tip);   //      
                     }   
                  break;
//--------------------------------------------------------------------------------- 10 --
               case 1:                                   // 
                  if (NormalizeDouble(Data-Last_Max,Digits)>0.0)
                     {
                     Last_Max = Data;
                     if (NormalizeDouble(Last_Max-Pr_Max,Digits)>0.0)//  
                        {   
                        Tip = 0;                         //    
                        Vert_Obj(Time[Last_V],Pr_Min,Pr_Max,1);//   i   
               //----
                        bb = Close[i];
                        ss = ss - Close[i];
                        SS = NormalizeDouble(ss/Point,0);
                        Rez = Rez + SS;
                        Ord++;
                        Ts_Name =  Prefix + (Time[i]+1);                        
                        ObjectCreate (Ts_Name, OBJ_TEXT, 0,Time[i], Pr_Min-5*Point);//  
                        if (SS>0)
                           ObjectSetText(Ts_Name, "+"+SS, 8, "Tahoma", Green);
                        else
                           ObjectSetText(Ts_Name,    ""+SS, 8, "Tahoma", Red);
               //----
                        }      
                     Vert(Last_V,Pr_Min,Last_Max,Tip);   //      
                     }
                  if (NormalizeDouble(Data-(Last_Max-delta),Digits)<=0.0)//.
                     {
                     Vector = -1;                        //  - 
                     Pr_Max = Last_Max;                  //   
                     Last_Min = Data;                    //  
                     Gorz(Last_V,i,Pr_Max,1);            //   . Close
                     Last_V = i;                         //   
                     Vert(Last_V,Pr_Max,Last_Min,1);     //      
                     }
                  break;
//--------------------------------------------------------------------------------- 10 --
               }
            break;
//================================================================================== 9 ==
         case 0:                                         //  
            switch(Vector)                               //  
               {
//--------------------------------------------------------------------------------- 10 --
               case 1:                                   //  (  )
                  if (NormalizeDouble(Data-Last_Max,Digits)>0.0)
                     {
                     Last_Max = Data;
                     Vert(Last_V,Pr_Min,Last_Max,Tip);   //      
                     }
                  if (NormalizeDouble(Data-(Last_Max-delta),Digits)<=0.0)//
                     {
                     Vector = -1;                        //  - 
                     Pr_Max = Last_Max;                  //   
                     Last_Min = Data;   
                     Gorz(Last_V,i,Pr_Max,0);            //   . Close
                     Last_V = i;                         //   
                     if (NormalizeDouble(Last_Min-Pr_Min,Digits)<0.0)//  
                        {
                        Tip = 1;                         //    
                        Vert_Obj(Time[Last_V],Pr_Min,Pr_Max,0);//   i   
               //----
                        ss = Close[i];
                        bb = Close[i] - bb;
                        BB = NormalizeDouble(bb/Point,0);
                        Rez = Rez + BB;
                        Ord++;
                        Ts_Name =  Prefix + (Time[i]+1);                        
                        ObjectCreate (Ts_Name, OBJ_TEXT, 0,Time[i], Pr_Max+5*Point);
                        if (BB>0)
                           ObjectSetText(Ts_Name, "+"+BB, 8, "Tahoma", Green);
                        else
                           ObjectSetText(Ts_Name,    ""+BB, 8, "Tahoma", Red);
               //----
                        }
                     Vert(Last_V,Pr_Max,Last_Min,Tip);   //      
                     }   
                  break;
//--------------------------------------------------------------------------------- 10 --
               case -1:                                  // 
                  if (NormalizeDouble(Data-Last_Min,Digits)<0.0)
                     {
                     Last_Min = Data;
                     if (NormalizeDouble(Last_Min-Pr_Min,Digits)<0.0)//  
                        {   
                        Tip = 1;                         //    
                        Vert_Obj(Time[Last_V],Pr_Max,Pr_Min,0);//   i   
               //----
                        ss = Close[i];
                        bb = Close[i] - bb;
                        BB = NormalizeDouble(bb/Point,0);
                        Rez = Rez + BB;
                        Ord++;
                        Ts_Name =  Prefix + (Time[i]+1);                        
                        ObjectCreate (Ts_Name, OBJ_TEXT, 0,Time[i], Pr_Max+5*Point);
                        if (BB>0)
                           ObjectSetText(Ts_Name, "+"+BB, 8, "Tahoma", Green);
                        else
                           ObjectSetText(Ts_Name,    ""+BB, 8, "Tahoma", Red);
               //----
                        }      
                     Vert(Last_V,Pr_Max,Last_Min,Tip);   //      
                     }
                  if (NormalizeDouble(Data-(Last_Min+delta),Digits)>=0.0)//.
                     {
                     Vector = 1;                         //  - 
                     Pr_Min = Last_Min;                  //   
                     Last_Max = Data;                    //  
                     Gorz(Last_V,i,Pr_Min,0);            //   . Close
                     Last_V = i;                         //   
                     Vert(Last_V,Pr_Min,Last_Max,0);     //      
                     }
                  break;
//--------------------------------------------------------------------------------- 10 --
               }
            break;
//================================================================================== 9 ==
         }
//--------------------------------------------------------------------------------- 10 --
      if (i==1)
         {   
         Ts_Name =  Prefix + "1";                        
         ObjectCreate (Ts_Name, OBJ_LABEL, 0, 0, 0);              //  
         ObjectSet    (Ts_Name, OBJPROP_XDISTANCE, 10);           //   
         ObjectSet    (Ts_Name, OBJPROP_YDISTANCE, 115);           //   
         ObjectSet    (Ts_Name, OBJPROP_CORNER, 1);               //  
         ObjectSetText(Ts_Name, " "+Ord,10,"Tahoma",Blue); //  
//--------------------------------------------------------------------------------- 10 --
         Ts_Name =  Prefix + "2";                        
         ObjectCreate (Ts_Name, OBJ_LABEL, 0, 0, 0);              //  
         ObjectSet    (Ts_Name, OBJPROP_XDISTANCE, 10);           //   
         ObjectSet    (Ts_Name, OBJPROP_YDISTANCE, 130);           //   
         ObjectSet    (Ts_Name, OBJPROP_CORNER, 1);               //  
         ObjectSetText(Ts_Name, " "+Ord*SPREAD+" ",10,"Tahoma",Red);
//--------------------------------------------------------------------------------- 10 --
         Ts_Name =  Prefix + "3";                        
         ObjectCreate (Ts_Name, OBJ_LABEL, 0, 0, 0);              //  
         ObjectSet    (Ts_Name, OBJPROP_XDISTANCE, 10);           //   
         ObjectSet    (Ts_Name, OBJPROP_YDISTANCE, 145);           //   
         ObjectSet    (Ts_Name, OBJPROP_CORNER, 1);               //  
         if (Rez>0)
            ObjectSetText(Ts_Name, " +"+Rez+" ",10,"Tahoma",Green);
         else
            ObjectSetText(Ts_Name, " " +Rez+" ",10,"Tahoma",Red);
//--------------------------------------------------------------------------------- 10 --
         Ts_Name =  Prefix + "4";                        
         ObjectCreate (Ts_Name, OBJ_LABEL, 0, 0, 0);              //  
         ObjectSet    (Ts_Name, OBJPROP_XDISTANCE, 10);           //   
         ObjectSet    (Ts_Name, OBJPROP_YDISTANCE, 160);           //   
         ObjectSet    (Ts_Name, OBJPROP_CORNER, 1);               //  
         if (Rez-Ord*SPREAD>0)
            ObjectSetText(Ts_Name, " +"+(Rez-Ord*SPREAD)+" ",14,"Tahoma", Green);
         else
            ObjectSetText(Ts_Name, " " +(Rez-Ord*SPREAD)+" ",14,"Tahoma", Red);
         }
//--------------------------------------------------------------------------------- 10 --
      i--;
      }
//================================================================================= 12 ==
   return;
   }
// 4 
int deinit()
   {
   int Qnt_Obj_Del = 0;                         //     
   int Kol_Objects = ObjectsTotal();            //   
   string Mas_Name_Del[1];                      //  
   ArrayResize(Mas_Name_Del, Kol_Objects);      //   
//--------------------------------------------------------------------------------- 41 --
   for (int k=0; k < Kol_Objects; k++)          //   
      {
      string Obj_Name = ObjectName(k);          //   
      string Bebin = StringSubstr(Obj_Name,0,8);//   8   
      if (Bebin == Prefix)                      //   ,   ..
         {                                      // ..    
         Qnt_Obj_Del=Qnt_Obj_Del+1;             //     
         Mas_Name_Del[Qnt_Obj_Del]=Obj_Name;    //    
         }
      }
//--------------------------------------------------------------------------------- 42 --
   for (int i=1; i<=Qnt_Obj_Del; i++)           //     
      ObjectDelete(Mas_Name_Del[i]);            //  
   WindowRedraw();                              //   
   return;
   }
// 5 
int Vert_Obj(int TT, double Price_1, double Price_2, int Tip)
   {                                                  //  . - 
//================================================================================= 24 ==
   string Line_Name = Prefix + TT;                    //  
   ObjectCreate (Line_Name, OBJ_TREND, 0, 0, 0, 0, 0);//  
   ObjectSet    (Line_Name, OBJPROP_TIME1, TT);       //  
   ObjectSet    (Line_Name, OBJPROP_TIME2, TT);       //  
   ObjectSet    (Line_Name, OBJPROP_PRICE1, Price_1); //  
   ObjectSet    (Line_Name, OBJPROP_PRICE2, Price_2); //  
   ObjectSet    (Line_Name, OBJPROP_RAY, false);      //  
   ObjectSet    (Line_Name, OBJPROP_STYLE, 0 );       //  -  
   ObjectSet    (Line_Name, OBJPROP_WIDTH, Width+1);  //  
   if (Tip == 0)                                      // 
      ObjectSet (Line_Name, OBJPROP_COLOR, Color_1);  //  
   else
      ObjectSet (Line_Name, OBJPROP_COLOR, Color_2);  //  
//================================================================================= 25 ==
   return;
   }
// 8 
int Vert(int i, double Price_1, double Price_2, int Tip)
   {                                         //       
   double max = MathMax(Price_1, Price_2) ;  //    .  
   double min = MathMin(Price_1, Price_2) ;
//================================================================================== 9 ==
   if (Tip == 0)                             // 
      {
      Ver_B[i]= max;
      Ver_S[i]= min;
      }
//--------------------------------------------------------------------------------- 10 --
    else                                     // 
      {
      Ver_B[i]= min;
      Ver_S[i]= max;
      }  
   return;
//================================================================================== 9 ==
   }
// 8 
int Gorz(int ind_1, int ind_2, double Price, int Tip)
   {                                            //  .     
   double ind_max = MathMax(ind_1, ind_2) ;     //  .  . 
   double ind_min = MathMin(ind_1, ind_2) ;
   static int Buf = 0;
   Buf++;
   if (Buf==4)Buf=1;
//================================================================================== 9 ==
   for (int n=ind_min; n<=ind_max; n++)
      {
//--------------------------------------------------------------------------------- 10 --
      if (Tip == 0)                             //   
         {
         switch(Buf)                            //   
            {
            case 1: Gor_B1[n]= Price; break;
            case 2: Gor_B2[n]= Price; break;
            case 3: Gor_B3[n]= Price; 
            }
         }   
//--------------------------------------------------------------------------------- 10 --
      else                                      //   
         {
         switch(Buf)                            //   
            {
            case 1: Gor_S1[n]= Price; break;
            case 2: Gor_S2[n]= Price; break;
            case 3: Gor_S3[n]= Price; 
            }
         }   
//--------------------------------------------------------------------------------- 10 --
      }
   return;
   }
//    13 